// DataSocket.cpp : implementation file
//

#include "stdafx.h"
#include "DreamSpot.h"
#include "DataSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDataSocket

CDataSocket::CDataSocket()
{
}

CDataSocket::~CDataSocket()
{
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CDataSocket, CSocket)
	//{{AFX_MSG_MAP(CDataSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CDataSocket member functions

void CDataSocket::Init(CWnd *pWnd)
{
	m_pWnd=pWnd;
	m_pFile=new CSocketFile(this);
	m_pArchiveIn=new CArchive(m_pFile,CArchive::load);
	m_pArchiveOut=new CArchive(m_pFile,CArchive::store);
}

void CDataSocket::Send(CData *pData)
{
	if(m_pArchiveOut!=NULL)
		pData->Serialize(*m_pArchiveOut);
}

void CDataSocket::Receive(CData *pData)
{
	if(m_pArchiveIn!=NULL) pData->Serialize(*m_pArchiveIn);
}

void CDataSocket::operator << (CData &data)
{
	Send(&data);
	Flush();
}

void CDataSocket::operator >> (CData &data)
{
	Receive(&data);
}

void CDataSocket::Flush()
{
	if(m_pArchiveOut!=NULL)
		m_pArchiveOut->Flush();
}

void CDataSocket::OnClose(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(m_pFile!=NULL)
	{
		delete m_pFile;
		m_pFile=NULL;
	}
	if(m_pArchiveIn!=NULL)
	{
		m_pArchiveIn->Abort();
		delete m_pArchiveIn;
		m_pArchiveIn=NULL;
	}
	if(m_pArchiveOut!=NULL)
	{
		m_pArchiveOut->Abort();
		delete m_pArchiveOut;
		m_pArchiveOut=NULL;
	}
	CSocket::OnClose(nErrorCode);
}

void CDataSocket::OnReceive(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_pWnd->SendMessage(UM_DATARECEIVE);
	CSocket::OnReceive(nErrorCode);
}
