// DreamSpotView.cpp : implementation of the CDreamSpotView class
//

#include "stdafx.h"
#include "DreamSpot.h"

#include "DreamSpotDoc.h"
#include "DreamSpotView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDreamSpotView

IMPLEMENT_DYNCREATE(CDreamSpotView, CView)

BEGIN_MESSAGE_MAP(CDreamSpotView, CView)
	//{{AFX_MSG_MAP(CDreamSpotView)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_GameStart, OnGameStart)
	ON_COMMAND(ID_IMClient, OnIMClient)
	ON_COMMAND(ID_NetStop, OnNetStop)
	ON_UPDATE_COMMAND_UI(ID_IMClient, OnUpdateIMClient)
	ON_UPDATE_COMMAND_UI(ID_NetStop, OnUpdateNetStop)
	ON_UPDATE_COMMAND_UI(ID_GameStart, OnUpdateGameStart)
	ON_WM_ERASEBKGND()
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW, OnUpdateFilePrintPreview)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_SETUP, OnUpdateFilePrintSetup)
	ON_WM_TIMER()
	ON_COMMAND(ID_STONENO, OnStoneno)
	ON_UPDATE_COMMAND_UI(ID_STONENO, OnUpdateStoneno)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_MESSAGE(UM_ACCEPT,OnAccept)
	ON_MESSAGE(UM_DATARECEIVE,OnReceive)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDreamSpotView construction/destruction

CDreamSpotView::CDreamSpotView()
{
	Sounded=FALSE;
	GameStu=0;
	DB_Button1=CRect(575,282,620,303);
	DB_Button2=CRect(575,310,620,331);
	DB_Button3=CRect(575,337,620,358);
}

CDreamSpotView::~CDreamSpotView() { }

BOOL CDreamSpotView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDreamSpotView drawing
void CDreamSpotView::OnDraw(CDC* pDC)
{
	int x,y;

	CPoint Heres;
	CDreamSpotDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CDC cdc;
	cdc.CreateCompatibleDC(pDC);

	// ׸
	for(x=0; x<19; x++)
		for(y=0; y<19; y++)
		{
			if(pDoc->DreamBD.SpotMan.StoneMan[x][y].StoneColor==1) cdc.SelectObject(&bm_BlackStone);
			else cdc.SelectObject(&bm_WhiteStone);
			if(pDoc->DreamBD.SpotMan.StoneMan[x][y].StoneColor!=0)
			{
				Heres=pDoc->DreamBD.Point2Pixel(CPoint(x,y));
				pDC->BitBlt(Heres.x,Heres.y,25,25,&cdc,0,0,SRCCOPY);                
			}
		}

	if(GameStu>0) DrawTurn();
	pDoc->DreamBD.SpotMan.DispSpotInfo(pDC);
	cdc.SelectStockObject(BLACK_PEN);
}

/////////////////////////////////////////////////////////////////////////////
// CDreamSpotView printing

BOOL CDreamSpotView::OnPreparePrinting(CPrintInfo* pInfo)
{
	return DoPreparePrinting(pInfo);
}

void CDreamSpotView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) {}
void CDreamSpotView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) {}

/////////////////////////////////////////////////////////////////////////////
// CDreamSpotView diagnostics

#ifdef _DEBUG
void CDreamSpotView::AssertValid() const
{
	CView::AssertValid();
}

void CDreamSpotView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDreamSpotDoc* CDreamSpotView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDreamSpotDoc)));
	return (CDreamSpotDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDreamSpotView message handlers

void CDreamSpotView::OnInitialUpdate() 
{
	CDreamSpotDoc* pDoc = GetDocument();
	CView::OnInitialUpdate();
	
	bm_BlackStone.LoadBitmap(IDB_BLACK);
	bm_WhiteStone.LoadBitmap(IDB_WHITE);
	bm_BBoardIMG.LoadBitmap(IDB_BITMAP);
	bm_DreamTitle.LoadBitmap(IDB_TITLE);
	bm_DreamBottom.LoadBitmap(IDB_BOTTOM);
	bm_DreamScore.LoadBitmap(IDB_SCORE);
	bm_DreamTurn1.LoadBitmap(IDB_TURN1);
	bm_DreamTurn2.LoadBitmap(IDB_TURN2);
	bm_DreamButton.LoadBitmap(IDB_DBUTTON);
	bm_DreamButton2.LoadBitmap(IDB_DBUTTON2);

	pDoc->m_ServerSocket.Init(this,4242);
}

void CDreamSpotView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int SpotPos;
	CData data;
	CDC* pDC=GetDC();
	CDreamSpotDoc* pDoc = GetDocument();
	  
	// 谡 ư
	if(DB_Button1.PtInRect(point)==TRUE)
	{
		// 缮..
		// 谡 û
		CData It;
		It.MsgMode=5;
		pDoc->m_DataSocket << It;
		pDoc->DreamRule.ChangeTurn();
	}
	// 
	if(DB_Button2.PtInRect(point)==TRUE)
	{
		//  ξ   ΰ ?
		//pDoc->DreamBD.SpotMan.GetColorFromHistory(pDoc->DreamBD.SpotMan.GetHistoryNumber());
		//pDoc->DreamBD.SpotMan.ReverseSpot(pDoc->DreamBD.SpotMan.GetHistoryNumber());
		//pDoc->DreamBD.SpotMan.GetNumberFromHistory(pDoc->DreamBD.SpotMan.GetHistoryNumber());
		CData It;
		It.MsgMode=6;
		pDoc->m_DataSocket << It;
		pDoc->DreamRule.ChangeTurn();
	}
	// 
	if(DB_Button3.PtInRect(point)==TRUE)
	{
		if(GameStu==1 || GameStu==2)
		{
			if((GameStu==2) && (pDoc->DreamRule.IsTurn()==pDoc->Human.MyColor))
			{
				CData It;
				It.MsgMode=4;
				pDoc->m_DataSocket << It;
				pDoc->DreamRule.ChangeTurn();
			}
			else if(GameStu==1) pDoc->DreamRule.ChangeTurn();
			else return;
			DrawTurn();	}
	}

	if((SpotPos=pDoc->DreamBD.StoneInRegion(point))<=361)
	{
		switch(GameStu)
		{
		    case 0 :
				break;
			case 1:
				if(pDoc->DreamRule.CanDropHere(pDoc->DreamBD.Position2Point(SpotPos),pDoc->DreamRule.IsTurn(),pDoc->DreamBD.SpotMan)==TRUE)
				{
					//  
					if(pDoc->DreamBD.DropStone(pDoc->DreamBD.Position2Point(SpotPos),pDoc->DreamRule.IsTurn()))
					{
						DrawStone(pDoc->DreamRule.IsTurn(),pDoc->DreamBD.Position2Point(SpotPos));
						pDoc->DreamRule.ChangeTurn();         //  ٲٱ
						KillTimer(WM_USER_TIMER);
						SetTimer(WM_USER_TIMER,1000,NULL);
						if(pDoc->DreamRule.FindDeadStone(pDoc->DreamBD.Position2Point(SpotPos),pDoc->DreamBD.SpotMan,pDoc->DreamRule.IsTurn())==TRUE) Invalidate();
						DrawTurn();
					}
				}
				break;
			case 2:
				if(pDoc->Human.MyColor==pDoc->DreamRule.IsTurn())
				{
					if(pDoc->DreamRule.CanDropHere(pDoc->DreamBD.Position2Point(SpotPos),pDoc->DreamRule.IsTurn(),pDoc->DreamBD.SpotMan)==TRUE)
					{
						if(pDoc->DreamBD.DropStone(pDoc->DreamBD.Position2Point(SpotPos),pDoc->DreamRule.IsTurn()))
						{
							DrawStone(pDoc->DreamRule.IsTurn(),pDoc->DreamBD.Position2Point(SpotPos));
							KillTimer(WM_USER_TIMER);
							SetTimer(WM_USER_TIMER,1000,NULL);
							pDoc->DreamRule.ChangeTurn();         //  ٲٱ
							if(pDoc->DreamRule.FindDeadStone(pDoc->DreamBD.Position2Point(SpotPos),pDoc->DreamBD.SpotMan,pDoc->DreamRule.IsTurn())==TRUE)
							{
								Invalidate();
							}
							data.m_PointHere=pDoc->DreamBD.Position2Point(SpotPos);
							data.MsgMode=0;
							pDoc->m_DataSocket<<data;
							DrawTurn();
						}
					}
				}
				break;
		}
	}
	ReleaseDC(pDC);
	CView::OnLButtonDown(nFlags, point);
}


void CDreamSpotView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if(GameStu==2)
	{
		CDreamSpotDoc *pDoc=GetDocument();
		CSendMessage It;
		It.pDoc=pDoc;
		It.DoModal();
	}
	CView::OnRButtonDown(nFlags, point);
}

//   κ.................................................

void CDreamSpotView::OnConnect()
{
	CDreamSpotDoc *pDoc=GetDocument();
	CDlgAddress dlg;
	CGameSetDlg Game;
	
	if(Game.DoModal()==IDOK)
	{
		CDreamSpotDoc *pDoc=GetDocument();
		if(dlg.DoModal()==IDOK)
		{
			pDoc->m_DataSocket.Close();
			if(!pDoc->m_DataSocket.Create())
			{
				AfxMessageBox("  ");
				return;
			}
			
			if(!pDoc->m_DataSocket.Connect(dlg.m_strAddress,4242))
			{
				AfxMessageBox("Ҽ ϴ");
				GameStu=0;
				return;
			}
			pDoc->m_DataSocket.Init(this);
			
			pDoc->Human.MyColor=Game.m_SelColor;
			CData dGameSet;

			dGameSet.MsgMode=3;
			dGameSet.m_TotalTime=Game.m_TotalTime;
			dGameSet.m_StoneColor=pDoc->DreamRule.EnemyForce(Game.m_SelColor);
			dGameSet.TimesCho=Game.ChoTimes;
			dGameSet.TotalCho=Game.ChoTotal;
			
			pDoc->DreamRule.SetChoIt(Game.ChoTotal,Game.ChoTimes);
			pDoc->DreamRule.SetTurn(Game.m_SelColor);
			pDoc->DreamRule.SetGameTime(Game.m_TotalTime);
			pDoc->m_DataSocket << dGameSet;
			SetTimer(WM_USER_TIMER,1000,NULL);
			GameStu=2;
		}
		else GameStu=0;
		Invalidate();
	}
	else return;
}

LRESULT CDreamSpotView::OnAccept(WPARAM wParam, LPARAM lParam)
{
	CDreamSpotDoc *pDoc=GetDocument();
	m_YorNDlg.m_Question="  û ߽ϴ.  Ͻðڽϱ ?";
	if(m_YorNDlg.DoModal()==TRUE)
	{
		pDoc->m_DataSocket.Close();
		if(!pDoc->m_ServerSocket.Accept(pDoc->m_DataSocket))
		{
			AfxMessageBox(" 㰡 ");
			return 0L;
		}
		pDoc->m_DataSocket.Init(this);
	}
	else
	{
		pDoc->m_DataSocket.Close();
		pDoc->m_ServerSocket.Accept(pDoc->m_DataSocket);
		pDoc->m_DataSocket.Init(this);

		CData It;
		It.MsgMode=2;
		pDoc->m_DataSocket << It;
		GameStu=100;
	}
	Invalidate();
	return 0L;
}

LRESULT CDreamSpotView::OnReceive(WPARAM wParam, LPARAM lParam)
{
	CDreamSpotDoc *pDoc=GetDocument();
	CDC* pDC=GetDC();
	CData data;
	pDoc->m_DataSocket >> data;

	//   ϶...?
	switch(data.MsgMode)
	{
	case 0 :
		DrawStone(pDoc->DreamRule.IsTurn(),data.m_PointHere);
		if(pDoc->DreamBD.DropStone(data.m_PointHere,pDoc->DreamRule.IsTurn()))
		{
			DrawStone(pDoc->DreamRule.IsTurn(),data.m_PointHere);
			pDoc->DreamRule.ChangeTurn();         //  ٲٱ
			if(pDoc->DreamRule.FindDeadStone(data.m_PointHere,pDoc->DreamBD.SpotMan,pDoc->DreamRule.IsTurn())==TRUE)
				Invalidate();
			DrawTurn();
		}
		break;
	case 1 : // ޽  ϶... ̻ڰ  ø...
		m_SendedDlg.m_SendedMsg=data.s_ChatMessage;
		m_SendedDlg.DoModal();
		break;
	case 2 : //   , ź ...
		m_SendedDlg.m_SendedMsg="˼մϴ.  ȸ ε սô. (   Ǵ  ߽ϴ.)";
		m_SendedDlg.DoModal();
		KillTimer(WM_USER_TIMER);
		GameStu=0;
		// ٵ ʱȭ ϰ
		pDoc->DreamBD.InitBoard();
		//  ʱȭ ϰ
		// Ҷ ʱȭ ϴϱ ص  pDoc->DreamRule.InitTurn();
		//  ʱȭ Ѵ.
		pDoc->DreamBD.SpotMan.CleareScore();
		// ð ʱȭ Ѵ.
		pDoc->DreamRule.InitTime();
		//  Ʈ ʱȭ ؾ
		pDoc->DreamBD.SpotMan.ClearHistory();

		pDoc->m_DataSocket.Close();
		Invalidate();
		break;
	case 3 : //  ÿ ʱ⼳ û ...
		if(GameStu==100)
		{
			OnNetStop();
			return 0L;
		}
		GameStu=2;
		pDoc->Human.MyColor=data.m_StoneColor;
		pDoc->DreamRule.SetTurn(pDoc->DreamRule.EnemyForce(data.m_StoneColor));
		pDoc->DreamRule.SetGameTime(data.m_TotalTime);
		pDoc->DreamRule.SetChoIt(data.TotalCho,data.TimesCho);
		SetTimer(WM_USER_TIMER,1000,NULL);
		break;
	case 4 : //   ѱ⸦ ...
		pDoc->DreamRule.ChangeTurn(); //  ü
		DrawTurn(); //  ~
		break;
	case 5 : //  谡û  .
		m_YorNDlg.m_Question="谡 û  Խϴ.  Ͻðڽϱ ?";
		// if(m_YorNDlg.DoModal()==TRUE) else
		m_YorNDlg.DoModal();
		break;
	case 6 : //  ⸦ û  .
		m_YorNDlg.m_Question="˼մϴ. Ѽ  ǰڽϱ ?";
		// if(m_YorNDlg.DoModal()==TRUE) else
		m_YorNDlg.DoModal();
		break;
	case 7 :
	default : break;
	}
	return 0L;
}

// ׸ .........................................................

void CDreamSpotView::DrawStone(int Color, CPoint Here)
{
	CDC* pDC=GetDC();
	CDreamSpotDoc *pDoc=GetDocument();
	CDC cdc;
	cdc.CreateCompatibleDC(pDC);
	CPoint It;

	// /  
	if((pDoc->DreamRule.IsTurn())==TRUE) cdc.SelectObject(&bm_BlackStone);
	else cdc.SelectObject(&bm_WhiteStone);
	It=pDoc->DreamBD.Point2Pixel(Here);
	pDC->BitBlt(It.x,It.y,25,25,&cdc,0,0,SRCCOPY);                //  ׸
	ReleaseDC(pDC);
}

void CDreamSpotView::PrepareGame(CDC *pDD)
{
	CDC cdc;
	cdc.CreateCompatibleDC(pDD);
	CDreamSpotDoc *pDoc=GetDocument();

	int gX,gY;
	gX=500;
	gY=300;

	cdc.SelectObject(&bm_BBoardIMG);
	pDD->BitBlt(0,0,513,515,&cdc,0,0,SRCCOPY);

	cdc.SelectObject(&bm_DreamTitle);
	pDD->BitBlt(gX+10,0,176,58,&cdc,0,0,SRCCOPY);

	cdc.SelectObject(&bm_DreamBottom);
	pDD->BitBlt(gX+14,gY+107,181,126,&cdc,0,0,SRCCOPY);

	cdc.SelectObject(&bm_DreamScore);
	pDD->BitBlt(gX+14,gY-245,170,340,&cdc,0,0,SRCCOPY);

	cdc.SelectObject(&bm_DreamButton);
	pDD->BitBlt(gX+50,gY-20,170,340,&cdc,0,0,SRCCOPY);
}
	 
void CDreamSpotView::DrawTurn()
{
	CDC* pDD=GetDC();
	CDreamSpotDoc *pDoc=GetDocument();
	CString AneMessage;

	CDC cdc;
	cdc.CreateCompatibleDC(pDD);

	CFont FixedFont;
	FixedFont.CreateFont(12,6,0,0,0,0,0,0,1,0,0,0,0,"");
	pDD->SelectObject(FixedFont);

	int gX,gY;
	gX=500;
	gY=300;

	cdc.SelectObject(&bm_DreamTurn2);
	pDD->BitBlt(gX+90,gY-200,34,29,&cdc,0,0,SRCCOPY);
	pDD->BitBlt(gX+90,gY-100,34,29,&cdc,0,0,SRCCOPY);

	cdc.SelectObject(&bm_DreamTurn1);
	if(pDoc->DreamRule.IsTurn()==1)
	{
		AneMessage.Format("  ()   Դϴ.");
		pDD->BitBlt(gX+90,gY-200,34,29,&cdc,0,0,SRCCOPY);
	}
	else
	{
		AneMessage.Format("  ()   Դϴ.");
		pDD->BitBlt(gX+90,gY-100,34,29,&cdc,0,0,SRCCOPY);
	}

	if(GameStu==2)
	{
		if(pDoc->Human.MyColor!=pDoc->DreamRule.IsTurn())
		{
			cdc.SelectObject(&bm_DreamButton2);
			pDD->BitBlt(gX+50,gY-20,170,340,&cdc,0,0,SRCCOPY);
		}
		else
		{
			cdc.SelectObject(&bm_DreamButton);
			pDD->BitBlt(gX+50,gY-20,170,340,&cdc,0,0,SRCCOPY);
		}
	}

	CBitmap AnneMan;
	AnneMan.LoadBitmap(IDB_DOLDOL);
	cdc.SelectObject(&AnneMan);
	pDD->BitBlt(10,508,30,30,&cdc,0,0,SRCCOPY);
	
	pDD->TextOut(30,515,AneMessage);
	ReleaseDC(pDD);
}

BOOL CDreamSpotView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	CDreamSpotDoc *pDoc=GetDocument();
	CView::OnEraseBkgnd(pDC);
	PrepareGame(pDC);
	pDoc->DreamRule.ShowTime(pDC);
	return TRUE;
}

// ޴ ..........................................................
// GameStu=0;   
// GameStu=1;    (2ο)
// GameStu=2;  Ʈ 
// GameStu=3;  Ʈ 

void CDreamSpotView::OnGameStart() 
{
	CGameSetDlg Game;
	CDC* pDC=GetDC();
	if(Game.DoModal()==IDOK)
	{
		CDreamSpotDoc *pDoc=GetDocument();
		pDoc->DreamRule.SetTurn(Game.m_SelColor);
		pDoc->DreamRule.SetGameTime(Game.m_TotalTime);
		pDoc->DreamRule.SetChoIt(Game.ChoTotal,Game.ChoTimes);
		SetTimer(WM_USER_TIMER,1000,NULL);
		GameStu=1;
		DrawTurn();
	}
	ReleaseDC(pDC);
}

void CDreamSpotView::OnUpdateGameStart(CCmdUI* pCmdUI) 
{
	if(GameStu==0) pCmdUI->Enable(TRUE);
	else pCmdUI->Enable(FALSE);
}

// Ʒ  Լ ̸ Ŭ̾Ʈ
void CDreamSpotView::OnIMClient() 
{
	OnConnect();
}
void CDreamSpotView::OnUpdateIMClient(CCmdUI* pCmdUI) 
{
	if(GameStu==0) pCmdUI->Enable(TRUE);
	else pCmdUI->Enable(FALSE);	
}

void CDreamSpotView::OnNetStop() 
{
	CDreamSpotDoc *pDoc=GetDocument();
	// Ʈ  ! Ǵ  
	// ʿ  ߴٰ ִ Լ 
	if(GameStu==2)
	{
		if(AfxMessageBox("  ϰڽϱ?",MB_ICONQUESTION | MB_YESNO)==IDYES)
		{
			CData data;
			data.MsgMode=2;
			pDoc->m_DataSocket<<data;
		}
		else return;
	}

	KillTimer(WM_USER_TIMER);

	GameStu=0;
	// ٵ ʱȭ ϰ
	pDoc->DreamBD.InitBoard();
	//  ʱȭ ϰ
	// Ҷ ʱȭ ϴϱ ص  pDoc->DreamRule.InitTurn();
	//  ʱȭ Ѵ.
	pDoc->DreamBD.SpotMan.CleareScore();
	// ð ʱȭ Ѵ.
	pDoc->DreamRule.InitTime();
	//  Ʈ ʱȭ ؾ
	pDoc->DreamBD.SpotMan.ClearHistory();
	Invalidate();
}

void CDreamSpotView::OnUpdateNetStop(CCmdUI* pCmdUI) 
{
	if(GameStu==2 || GameStu==1) pCmdUI->Enable(TRUE);
	else pCmdUI->Enable(FALSE);
}

void CDreamSpotView::OnUpdateFilePrint(CCmdUI* pCmdUI) { pCmdUI->Enable(FALSE); }
void CDreamSpotView::OnUpdateFilePrintPreview(CCmdUI* pCmdUI) {	pCmdUI->Enable(FALSE);}
void CDreamSpotView::OnUpdateFilePrintSetup(CCmdUI* pCmdUI) { pCmdUI->Enable(FALSE);}

void CDreamSpotView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CDreamSpotDoc *pDoc = GetDocument();
	if((pDoc->DreamRule.m_dwBlackTime>0) && (pDoc->DreamRule.m_dwBlackTime>0)) pDoc->DreamRule.CountTimer(GetDC());
	else
	{
		if(Sounded!=TRUE)
		{
			Sounded=TRUE;
			pDoc->DreamRule.StartCho();
		}
	}
	CView::OnTimer(nIDEvent);
}

void CDreamSpotView::OnUpdateStoneno(CCmdUI* pCmdUI) 
{
	if(GameStu==2 || GameStu==1) pCmdUI->Enable(TRUE);
	else pCmdUI->Enable(FALSE);
}

void CDreamSpotView::OnStoneno() 
{
	CDC *pDC = GetDC();
	CDreamSpotDoc *pDoc = GetDocument();
	CPoint Here;
	CString Number;
	int MaxStone;
	int Nums;
	
	CFont FixedFont;
	FixedFont.CreateFont(9,4,0,0,0,0,0,0,1,0,0,0,0,"FixedSys");
	
	pDC->SelectObject(FixedFont);

	pDC->SetBkMode(TRANSPARENT);

	if((MaxStone=pDoc->DreamBD.SpotMan.GetHistoryNumber())<=1) return;
	
	for(int i=2; i<=MaxStone; i++)
	{
		Here=pDoc->DreamBD.SpotMan.GetPointFromHistory(i);
		Here=pDoc->DreamBD.Point2Pixel(Here);
		if((pDoc->DreamBD.SpotMan.GetColorFromHistory(i))==1) pDC->SetTextColor(RGB(255,255,255));
		else pDC->SetTextColor(RGB(0,0,0));
		Nums=pDoc->DreamBD.SpotMan.GetNumberFromHistory(i);
		Here.x+=9;
		Here.y+=5;
	    Number.Format("%d",Nums);
		if(Nums>9) Here.x-=4;
		if(Nums>99) Here.x-=4;
		pDC->TextOut(Here.x,Here.y,Number);
	}
}

void CDreamSpotView::PlayerWin(int StoneColor)
{
	if(StoneColor==1) AfxMessageBox(" ̰ϴ.");
	else if(StoneColor==2) AfxMessageBox(" ̰ϴ.");
}
