// DreamSpotView.h : interface of the CDreamSpotView class
// 
/////////////////////////////////////////////////////////////////////////////
#include "DlgAddress.h"
#include "SendMessage.h"
#include "GameSetDlg.h"
#include "SendedMsgDlg.h"
#include "YesNoDlg.h"

#if !defined(AFX_DREAMSPOTVIEW_H__6A42F54D_C099_11D5_946F_00C026E59373__INCLUDED_)
#define AFX_DREAMSPOTVIEW_H__6A42F54D_C099_11D5_946F_00C026E59373__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define WM_USER_TIMER	WM_USER + 1

class CDreamSpotDoc;

class CDreamSpotView : public CView
{
protected: // create from serialization only
	CDreamSpotView();
	DECLARE_DYNCREATE(CDreamSpotView)

// Attributes
public:
	CDreamSpotDoc* GetDocument();
	CSendedMsgDlg m_SendedDlg;
	CYesNoDlg m_YorNDlg;
	
private :
	CBitmap bm_BBoardIMG;
	CBitmap bm_BlackStone;
	CBitmap bm_WhiteStone;
	CBitmap bm_DreamTitle;
	CBitmap bm_DreamBottom;
	CBitmap bm_DreamScore;
	CBitmap bm_DreamTurn1;
	CBitmap bm_DreamTurn2;
	CBitmap bm_DreamButton;
	CBitmap bm_DreamButton2;

	CRect DB_Button1;
	CRect DB_Button2;
	CRect DB_Button3;

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDreamSpotView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	bool Sounded;
	void PlayerWin(int StoneColor);
	void DrawTurn();
	void PrepareGame(CDC *pDD);
	void DrawStone(int Color,CPoint Here);
	virtual ~CDreamSpotView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	int GameStu;
// Generated message map functions
protected:
	afx_msg LRESULT OnAccept(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnReceive(WPARAM wParam, LPARAM lParam);
	afx_msg void OnConnect();
	//{{AFX_MSG(CDreamSpotView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnGameStart();
	afx_msg void OnIMClient();
	afx_msg void OnNetStop();
	afx_msg void OnUpdateIMClient(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNetStop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGameStart(CCmdUI* pCmdUI);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrintSetup(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnStoneno();
	afx_msg void OnUpdateStoneno(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DreamSpotView.cpp
inline CDreamSpotDoc* CDreamSpotView::GetDocument()
   { return (CDreamSpotDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DREAMSPOTVIEW_H__6A42F54D_C099_11D5_946F_00C026E59373__INCLUDED_)
