// GameBoard.cpp: implementation of the CGameBoard class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DreamSpot.h"
#include "GameBoard.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGameBoard::CGameBoard()
{
	int Bx,By,AvaPos;
	
	AvaPos=0;
	CPoint Temp;
	StoneNumber=1;

	InitBoard();
    // ٵǿ   ִ  
	for(Bx=0;Bx<19;Bx++)
		for(By=0;By<19;By++)
		{
			Temp=Point2Pixel(CPoint(Bx,By));
			AvaRegion[AvaPos++]=CRect(CPoint(Temp.x+5,Temp.y+5),CPoint(Temp.x+19,Temp.y+19));
		}
}

CGameBoard::~CGameBoard()
{

}


int CGameBoard::StoneInRegion(CPoint CHere)
{
	int Pos;
	int Placed;
	for(Pos=0; Pos<361; Pos++)
	{
		//  Ʈ   ִ ΰ ˻
		if(AvaRegion[Pos].PtInRect(CHere)==TRUE)
		{
			Placed=Pos;
			break;
		}
		else Placed=361;
	}
	return Placed+1;
}

bool CGameBoard::DropStone(CPoint OhHere,int Stone)
{
	if(SpotMan.StoneMan[OhHere.x][OhHere.y].StoneColor==0)
	{
		//   ġ  ִ ˻
		//    , ġ   
		// ,,,쿡 ġ ִ  
		SpotMan.SpotList(Stone,OhHere);
		SpotMan.LastPoint=OhHere;
		SpotMan.StoneMan[OhHere.x][OhHere.y].StoneNo=StoneNumber++;
		SpotMan.AddHistory(OhHere);
		PlaySound(MAKEINTRESOURCE(IDR_WAVE1));
		return TRUE;
	}
	else return FALSE;
}

int CGameBoard::ShowPost(int x, int y)
{
	return SpotMan.StoneMan[x][y].StoneColor;
}

CPoint CGameBoard::Pixel2Point(CPoint PX)
{
	CPoint It;
	It.x=(PX.x/26)-8;
	It.y=(PX.y/26)-9;
	return It;
}

CPoint CGameBoard::Point2Pixel(CPoint PT)
{
	CPoint It;
	It.x=8+((PT.x)*26);
	It.y=9+((PT.y)*26);
	return It;
}

CPoint CGameBoard::Position2Point(int PT)
{
	int Verf;
	CPoint It;
	for(Verf=0; Verf<19; Verf++)
	{
		//   X,Y ǥ ϴ κ
		if(PT<=19+(Verf*19))
		{ 
			It.x=Verf; 
			It.y=PT-((Verf*19)+1);
			break;
		}
	}
	return It;
}

void CGameBoard::InitBoard()
{
	int Bx,By;
	// ٵ   
	for(Bx=0;Bx<19;Bx++)
		for(By=0;By<19;By++)
			SpotMan.StoneMan[Bx][By].StoneColor=0;

}

void CGameBoard::ShowSpotNumber(CDC *pDC)
{
	CDC cdc;
	cdc.CreateCompatibleDC(pDC);
	CPoint It,Here;
	int Count=SpotMan.GetHistoryNumber();

	for(int i=0; i<Count; i++)
	{
		//Here=
		It=Point2Pixel(Here);
		pDC->TextOut(It.x,It.y,(CString)SpotMan.ShowStoneNo(Here));
	}
}

void CGameBoard::PlaySound(LPCTSTR lpszSound)
{
	HRSRC hRes;
	HGLOBAL hData;
	BOOL bOK=FALSE;
	if((hRes=::FindResource(AfxGetResourceHandle(),lpszSound,_T("WAVE")))!=NULL &&	(hData=::LoadResource(AfxGetResourceHandle(),hRes)))
	{
		bOK=sndPlaySound((LPCTSTR)::LockResource(hData),SND_MEMORY|SND_ASYNC|SND_NODEFAULT);
		FreeResource(hData);
	}
}
