// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DreamSpot.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame() { }
CMainFrame::~CMainFrame() { }

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1) return -1;
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	m_wndComboBox.Create(WS_CHILD|CBS_DROPDOWNLIST|WS_VISIBLE,CRect(0,0,200,100),this,AFX_IDW_TOOLBAR);
	AddComboData("   ");
	m_wndComboBox.SetCurSel(0);
	m_wndReBar.Create(this);
	m_wndReBar.AddBar(&m_wndComboBox);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) ) return FALSE;

	cs.style &=~(WS_VSCROLL|WS_HSCROLL|WS_MAXIMIZEBOX|WS_THICKFRAME);
	int x=GetSystemMetrics(SM_CXMAXTRACK);
	int y=GetSystemMetrics(SM_CYMAXTRACK);
	x=(x-700)/2;
	y=(y-650)/2;
	cs.x=x;
	cs.y=y;
	cs.cx=700;
	cs.cy=650;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::AddComboData(CString It)
{
	COMBOBOXEXITEM item;
	item.mask=CBEIF_TEXT;
	item.iItem=-1;
	item.pszText=(LPSTR)(LPCTSTR)It;
	m_wndComboBox.InsertItem(&item);
}

int CMainFrame::ShowListNo()
{
	return m_wndComboBox.GetCount();
}

CPoint CMainFrame::GetPositionCPoint(int Number)
{
	char szTemp[100];
	char *sX,*sY;
	int iX=0,iY=0;
	CPoint It;
	
	if(m_wndComboBox.GetCount() < Number) return NULL;
	m_wndComboBox.GetLBText( Number, szTemp);
	
	if((sX=strchr(szTemp,'X'))!=NULL) iX=((sX[4]-48)*10)+(sX[5]-48);
	if((sY=strchr(szTemp,'Y'))!=NULL) iY=((sY[4]-48)*10)+(sY[5]-48);

	It.x=iX;
	It.y=iY;
	return It;
}

int CMainFrame::GetPositionColor(int Number)
{
	char szTemp[100];
	char *sColor;
    char sColor2[3];

	if(m_wndComboBox.GetCount() < Number) return NULL;
	m_wndComboBox.GetLBText( Number, szTemp );

	if((sColor=strchr(szTemp,'('))!=NULL)
	{
		sColor2[0]=sColor[1];
		sColor2[1]=sColor[2];
		sColor2[2]='\n';
	}

	if(strstr(sColor2,"")!=NULL) return 2;
	if(strstr(sColor2,"")!=NULL) return 1;
	
	return NULL;
}

int CMainFrame::GetPositionNumber(int Number)
{
	char szTemp[100];
	char It[3];
	char *NumPos;
	int Here;

	if(m_wndComboBox.GetCount() < Number) return NULL;
	m_wndComboBox.GetLBText( Number,szTemp);

	if((NumPos=strchr(szTemp,':'))!=NULL)
	{
		It[0]=NumPos[2];
		It[1]=NumPos[3];
		It[2]=NumPos[4];
	}

	Here=((It[0]-48)*100)+((It[1]-48)*10)+(It[2]-48);
	return Here;
}
