// SpotManager.cpp: implementation of the SpotManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DreamSpot.h"
#include "SpotManager.h"
#include "DreamSpotView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define f_UP	1
#define f_DOWN	2
#define f_LEFT	4
#define f_RIGHT	8

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SpotManager::SpotManager()
{
	CleareScore();
	ClearSpots();
}

SpotManager::~SpotManager()
{

}

void SpotManager::SpotList(int Cols,CPoint Wh)
{
	StoneMan[Wh.x][Wh.y].StoneColor=Cols;
}

void SpotManager::DispSpotInfo(CDC* pDC)
{
	CFont FixedFont;
	FixedFont.CreateFont(11,6,0,0,0,0,0,0,1,0,0,0,0,"");
	pDC->SelectObject(FixedFont);

	CString WhiteSC,BlackSC;
	WhiteSC.Format("%d",mb_WhiteScore);
	BlackSC.Format("%d",mb_BlackScore);
		
	pDC->TextOut(610,157,WhiteSC);
	pDC->TextOut(610,255,BlackSC);
}

int SpotManager::SetWayBlank(CPoint Wh)
{
	int Blank=0;
	if(ShowDown(Wh) ==0) Blank++;
	if(ShowUp(Wh)   ==0) Blank++;
	if(ShowLeft(Wh) ==0) Blank++;
	if(ShowRight(Wh)==0) Blank++;
	StoneMan[Wh.x][Wh.y].BlankWay=Blank;
	return Blank;
}

CPoint SpotManager::FindLiveWay(CPoint Heres)
{
	// 1. 
	// 2.絹 Ȱΰ ֳ 
	//    ÿ ġ ϰ Ȱ  ڿ װ 湮 ߴٴ ǥø Ѵ.
	//     ֳ 
	// 3.   ִ 
	// 4.  ڷ .   ϳ.

	CPoint StoneStack[181],TempStack;
	int StoneCount=0;
	ClearVisted();

	StoneStack[StoneCount]=Heres;

	while(1)
	{
		if(SetWayBlank(StoneStack[StoneCount])>=1) return CPoint(20,20);

		switch(NextLiveWay(StoneStack[StoneCount]))
		{
		case 1 : // 
			StoneMan[StoneStack[StoneCount].x][StoneStack[StoneCount].y-1].Visited=TRUE;
			TempStack=CPoint(StoneStack[StoneCount].x,StoneStack[StoneCount].y-1);
			StoneStack[++StoneCount]=TempStack;
			break;
		case 2 : // 
			StoneMan[StoneStack[StoneCount].x-1][StoneStack[StoneCount].y].Visited=TRUE;
			TempStack=CPoint(StoneStack[StoneCount].x-1,StoneStack[StoneCount].y);
			StoneStack[++StoneCount]=TempStack;
			break;
		case 3 : // 
			StoneMan[StoneStack[StoneCount].x+1][StoneStack[StoneCount].y].Visited=TRUE;
			TempStack=CPoint(StoneStack[StoneCount].x+1,StoneStack[StoneCount].y);
			StoneStack[++StoneCount]=TempStack;
			break;
		case 4 : // Ʒ
			StoneMan[StoneStack[StoneCount].x][StoneStack[StoneCount].y+1].Visited=TRUE;
			TempStack=CPoint(StoneStack[StoneCount].x,StoneStack[StoneCount].y+1);
			StoneStack[++StoneCount]=TempStack;
			break;
		case 0 :
			if((StoneCount==0) && (SetWayBlank(StoneStack[StoneCount])<=0)) return Heres;
			StoneCount--;
			break;
		}
	}
}

int SpotManager::NextLiveWay(CPoint Wh)
{
	int LiveWays=0;
	if(ShowColor(Wh)==ShowUp(Wh))
	{
		if(StoneMan[Wh.x][Wh.y-1].Visited==FALSE) LiveWays=1;
	}
	if(ShowColor(Wh)==ShowLeft(Wh))
	{
		if(StoneMan[Wh.x-1][Wh.y].Visited==FALSE) LiveWays=2;
	}
	if(ShowColor(Wh)==ShowRight(Wh))
	{
		if(StoneMan[Wh.x+1][Wh.y].Visited==FALSE) LiveWays=3;
	}
	if(ShowColor(Wh)==ShowDown(Wh))
	{
		if(StoneMan[Wh.x][Wh.y+1].Visited==FALSE) LiveWays=4;
	}
	return LiveWays;
}

void SpotManager::RemoveStone(CPoint Whe)
{
	int TempColor=ShowColor(Whe);
	
	DeleteHistory(Whe);

	StoneMan[Whe.x][Whe.y].BlankWay=0;
	StoneMan[Whe.x][Whe.y].StoneColor=0;
	StoneMan[Whe.x][Whe.y].StoneNo=0;

	if(TempColor==1) mb_BlackScore++;
	else if(TempColor==2) mb_WhiteScore++;
	
	if(TempColor==ShowUp(Whe)) RemoveStone(CPoint(Whe.x,Whe.y-1));
	if(TempColor==ShowLeft(Whe)) RemoveStone(CPoint(Whe.x-1,Whe.y));
	if(TempColor==ShowRight(Whe)) RemoveStone(CPoint(Whe.x+1,Whe.y));
	if(TempColor==ShowDown(Whe)) RemoveStone(CPoint(Whe.x,Whe.y+1));
}

void SpotManager::ClearVisted()
{
	int x,y;
	for(x=0; x<19; x++)
		for(y=0; y<19; y++) StoneMan[x][y].Visited=FALSE;
}

void SpotManager::AddHistory(CPoint Here)
{
	CString It;
	char *StCols;
	if(ShowColor(Here)==1) StCols="";
	else if(ShowColor(Here)==2) StCols="";
	It.Format(" : %03d(%s) [X : %02d] [Y : %02d]",ShowStoneNo(Here),StCols,Here.x,Here.y);
	((CMainFrame*)AfxGetMainWnd())->AddComboData(It);
}

void SpotManager::DeleteHistory(CPoint Here)
{
	CString It;
	char *StCols;
	int Pos;

	if(ShowColor(Here)==1) StCols="";
	else if(ShowColor(Here)==2) StCols="";
	It.Format(" : %03d(%s) [X : %02d] [Y : %02d]",ShowStoneNo(Here),StCols,Here.x,Here.y);

	if((Pos=((CMainFrame*)AfxGetMainWnd())->m_wndComboBox.FindStringExact(1,It))!=LB_ERR)
		((CMainFrame*)AfxGetMainWnd())->m_wndComboBox.DeleteItem(Pos);
}

void SpotManager::CleareScore()
{
	mb_BlackScore=0;
	mb_WhiteScore=0;
}

int SpotManager::ShowUp(CPoint It)
{
	if(It.y==0) return 3;
	else return StoneMan[It.x][It.y-1].StoneColor;
}

int SpotManager::ShowDown(CPoint It)
{
	if(It.y==18) return 3;
	else return StoneMan[It.x][It.y+1].StoneColor;
}

int SpotManager::ShowLeft(CPoint It)
{
	if(It.x==0) return 3;
	else return StoneMan[It.x-1][It.y].StoneColor;
}

int SpotManager::ShowRight(CPoint It)
{
	if(It.x==18) return 3;
	else return StoneMan[It.x+1][It.y].StoneColor;
}

int SpotManager::ShowColor(CPoint It)
{
	return StoneMan[It.x][It.y].StoneColor;
}

int SpotManager::ShowStoneNo(CPoint It)
{
	return StoneMan[It.x][It.y].StoneNo;
}

void SpotManager::ClearHistory()
{
	int MaxValue=GetHistoryNumber();
	for(int i=MaxValue; i>0; i--)
		((CMainFrame*)AfxGetMainWnd())->m_wndComboBox.DeleteItem(i);
}

void SpotManager::ReverseSpot(int StoneColor)
{
	CPoint It;
	CString Is;
	int LastStone=GetHistoryNumber();
	if(LastStone<=1) return;
	It=GetPointFromHistory(LastStone);
	Is.Format("%d %d",It.x,It.y);
	AfxMessageBox(Is);
}

CPoint SpotManager::GetPointFromHistory(int Number)
{
	if(Number<=1) return NULL;
	return ((CMainFrame*)AfxGetMainWnd())->GetPositionCPoint(Number-1);
}

int SpotManager::GetHistoryNumber()
{
	return ((CMainFrame*)AfxGetMainWnd())->m_wndComboBox.GetCount();
}

int SpotManager::GetColorFromHistory(int Number)
{
	if(Number<=1) return NULL;
	return ((CMainFrame*)AfxGetMainWnd())->GetPositionColor(Number-1);
}

int SpotManager::GetNumberFromHistory(int Number)
{
	if(Number<=1) return NULL;
 	return ((CMainFrame*)AfxGetMainWnd())->GetPositionNumber(Number-1);
}

void SpotManager::ClearSpots()
{
	int X,Y;
	for(X=0; X<19; X++)
		for(Y=0; Y<19; Y++)
		{
			StoneMan[X][Y].BlankWay=0;
			StoneMan[X][Y].StoneColor=0;
			StoneMan[X][Y].Visited=FALSE;
			StoneMan[X][Y].Dead=FALSE;
			StoneMan[X][Y].StoneNo=0;
		}
	LastPoint=CPoint(19,19);
}
